//  RDDTEST.C
//
//  Access VO DLLs using foreign hosted DLLs


#include <windows.h>
#include <commdlg.h>

#include "forrdd.h"

STATIC  achFileName[65];

LONG FAR PASCAL WndProc(HWND hwnd,
                        WORD message,
                        WORD wParam,
                        LONG lParam);


int PASCAL WinMain( HANDLE  hInstance,
                    HANDLE  hPrevInstance,
                    LPSTR   lpstrCmdLine,
                    int     nCmdShow)
{
    HWND            hwnd;
    MSG             msg;
    WNDCLASS        wndClass;
    OPENFILENAME    ofn;

    if(hPrevInstance)
    {
        return(-1);
    }

    wndClass.style          = CS_HREDRAW|CS_VREDRAW;
    wndClass.lpfnWndProc    = WndProc;
    wndClass.cbClsExtra     = 0;
    wndClass.cbWndExtra     = 0;
    wndClass.hInstance      = hInstance;
    wndClass.hIcon          = LoadIcon(NULL,
                                IDI_APPLICATION);
    wndClass.hCursor        = LoadCursor(NULL,
                                IDC_ARROW);
    wndClass.hbrBackground  = GetStockObject(
                                WHITE_BRUSH);
    wndClass.lpszMenuName   = NULL;
    wndClass.lpszClassName  = "RDDTEST";

    RegisterClass(&wndClass);


    if(!ForDBInit())
    {
        return(-1);
    }


    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = NULL;
    ofn.hInstance = hInstance;
    ofn.lpstrFilter = "DBF files (*.dbf)\0*.dbf\0\0";
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter = 0L;
    ofn.nFilterIndex = 1L;
    ofn.lpstrFile= achFileName;
    ofn.nMaxFile = sizeof(achFileName);
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle = "Select Database";
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
    ofn.nFileOffset = 0;
    ofn.nFileExtension = 0;
    ofn.lpstrDefExt = "DBF";
    ofn.lpfnHook = NULL;
    ofn.lpTemplateName = NULL;

    if(GetOpenFileName(&ofn))
    {

        ForDBUse("DBFNTX",achFileName,TRUE,FALSE);
        ForDBGoTop();

        hwnd=CreateWindow(  "RDDTEST",
                            "RDD Test",
                            WS_OVERLAPPEDWINDOW|
                            WS_VSCROLL|
                            WS_HSCROLL,
                            CW_USEDEFAULT,
                            CW_USEDEFAULT,
                            CW_USEDEFAULT,
                            CW_USEDEFAULT,
                            NULL,
                            NULL,
                            hInstance,
                            NULL);

        ShowWindow(hwnd,nCmdShow);
        UpdateWindow(hwnd);

        while(GetMessage(&msg,NULL,0,0))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }

        ForDBClose();
    }

    UnregisterClass("RDDTEST",hInstance);
    ForDBExit();

    return(msg.wParam);

}


LONG FAR PASCAL WndProc(HWND hwnd,
                        WORD message,
                        WORD wParam,
                        LONG lParam)
{
    STATIC  CHAR    achBuff[64];

    STATIC  SHORT   cxChar;
    STATIC  SHORT   cxCaps;
    STATIC  SHORT   cyChar;
    STATIC  LONG    lMaxWidth;

    STATIC  SHORT   nVscrollPos;
    STATIC  SHORT   nVscrollMax;
    STATIC  SHORT   nHscrollPos;
    STATIC  SHORT   nHscrollMax;

    STATIC  SHORT   cxClient;
    STATIC  SHORT   cyClient;

    STATIC  LONG    lLastRec;
    STATIC  WORD    wFCount;

    STATIC  WORD    wCurCol;

    STATIC  FORDBFIELDINFO fi;

    SHORT           nVscrollInc;
    SHORT           nHscrollInc;
    SHORT           x,y;

    WORD            nPaintBeg;
    WORD            nPaintEnd;
    WORD            i,j;

    HDC             hdc;
    HFONT           hFont;
    TEXTMETRIC      tm;
    PAINTSTRUCT     ps;

    RECT            rect;


    switch(message)
    {
        case WM_CREATE:

            hdc=GetDC(hwnd);

            hFont=GetStockObject(SYSTEM_FIXED_FONT);
            SelectObject(hdc,hFont);

            GetTextMetrics(hdc,&tm);

            cxChar=tm.tmAveCharWidth;
            cxCaps=(tm.tmPitchAndFamily&1?
                    3:2)*cxChar/2;
            cyChar=tm.tmHeight+
                    tm.tmExternalLeading;

            ReleaseDC(hwnd,hdc);

            lLastRec=ForDBLastRec();
            wFCount=ForDBFCount();

            lMaxWidth=0;
            for(i=1;i<=wFCount;i++)
            {
                ForDBField(&fi,i);
                if(fi.chType=='L')
                {
                    lMaxWidth+=4;
                }
                else
                {
                    lMaxWidth+=fi.wLen+1;
                }
            }

            lMaxWidth*=cxChar;

            wCurCol=1;

            return(0);


        case WM_SIZE:

            cyClient=HIWORD(lParam);
            cxClient=LOWORD(lParam);

            nVscrollMax=max(0,lLastRec+2-cyClient/cyChar);
            nVscrollPos=min(nVscrollPos,nVscrollMax);

            SetScrollRange(hwnd,SB_VERT,1,nVscrollMax,FALSE);
            SetScrollPos(hwnd,SB_VERT,nVscrollPos,TRUE);

            nHscrollMax=max(0,2+(lMaxWidth-cxClient)/cxChar);
            nHscrollPos=min(nHscrollPos,nHscrollMax);

            SetScrollRange(hwnd,SB_HORZ,0,nHscrollMax,FALSE);
            SetScrollPos(hwnd,SB_HORZ,nHscrollPos,TRUE);

            return(0);

        case WM_VSCROLL:

            switch(wParam)
            {
                case SB_TOP:
                    nVscrollInc=-nVscrollPos;
                    break;

                case SB_BOTTOM:
                    nVscrollInc=nVscrollMax-nVscrollPos;
                    break;

                case SB_LINEUP:
                    nVscrollInc=-1;
                    break;

                case SB_LINEDOWN:
                    nVscrollInc=1;
                    break;

                case SB_PAGEUP:
                    nVscrollInc=min(-1,-cyClient/cyChar+2);
                    break;

                case SB_PAGEDOWN:
                    nVscrollInc=max(1,cyClient/cyChar-2);
                    break;

                case SB_THUMBTRACK:
                    nVscrollInc=LOWORD(lParam)-nVscrollPos;
                    break;

                default:
                    nVscrollInc=0;

            }

            if(nVscrollInc=max(-nVscrollPos,
                min(nVscrollInc,nVscrollMax-nVscrollPos)))
            {

                rect.top    = cyChar;
                rect.left   = 0;
                rect.right  = cxClient;
                rect.bottom = cyClient;

                nVscrollPos+=nVscrollInc;
                ScrollWindow(hwnd,0,-cyChar*nVscrollInc,
                    &rect,&rect);
                SetScrollPos(hwnd,SB_VERT,nVscrollPos,TRUE);
                UpdateWindow(hwnd);
            }

            return(0);

        case WM_HSCROLL:

            switch(wParam)
            {
                case SB_LINEUP:
                case SB_PAGEUP:

                    if(wCurCol>1)
                    {
                        ForDBField(&fi,wCurCol-1);
                        if(fi.chType=='L')
                        {
                            fi.wLen=3;
                        }
                        nHscrollInc=-((SHORT)fi.wLen+1);
                        wCurCol--;
                    }
                    else
                    {
                        nHscrollInc=0;
                    }
                    break;

                case SB_LINEDOWN:
                case SB_PAGEDOWN:

                    if(wCurCol<wFCount)
                    {
                        ForDBField(&fi,wCurCol);
                        if(fi.chType=='L')
                        {
                            fi.wLen=3;
                        }
                        nHscrollInc=fi.wLen+1;
                        wCurCol++;
                    }
                    else
                    {
                        nHscrollInc=0;
                    }
                    break;

                case SB_THUMBPOSITION:

                    x=LOWORD(lParam);
                    nHscrollInc=0;

                    for(i=1;i<=wFCount;i++)
                    {
                        ForDBField(&fi,i);
                        if(fi.chType=='L')
                        {
                            fi.wLen=3;
                        }
                        nHscrollInc+=(fi.wLen+1);

                        if(nHscrollInc>x)
                        {
                            x=nHscrollInc-fi.wLen-1;
                            wCurCol=i;
                            break;
                        }
                    }

                    nHscrollInc=x-nHscrollPos;
                    break;

                default:
                    nHscrollInc=0;

            }

            if(nHscrollInc=max(-nHscrollPos,nHscrollInc))
            {
                nHscrollPos+=nHscrollInc;
                ScrollWindow(hwnd,-cxChar*nHscrollInc,0,
                    NULL,NULL);
                SetScrollPos(hwnd,SB_HORZ,nHscrollPos,TRUE);
                UpdateWindow(hwnd);
            }

            return(0);

        case WM_KEYDOWN:

            switch (wParam)
            {
                case VK_HOME:
                     SendMessage(hwnd,WM_VSCROLL,SB_TOP,0L);
                     break ;

                case VK_END :
                     SendMessage(hwnd,WM_VSCROLL,SB_BOTTOM,0L);
                     break ;

                case VK_PRIOR :
                     SendMessage(hwnd,WM_VSCROLL,SB_PAGEUP,0L);
                     break ;

                case VK_NEXT :
                     SendMessage(hwnd,WM_VSCROLL,SB_PAGEDOWN,0L);
                     break ;

                case VK_UP :
                     SendMessage(hwnd,WM_VSCROLL,SB_LINEUP,0L);
                     break ;

                case VK_DOWN :
                     SendMessage(hwnd,WM_VSCROLL,SB_LINEDOWN,0L);
                     break ;

                case VK_LEFT :
                     SendMessage(hwnd,WM_HSCROLL,SB_PAGEUP,0L);
                     break ;

                case VK_RIGHT :
                     SendMessage(hwnd,WM_HSCROLL,SB_PAGEDOWN,0L);
                     break ;
            }
            return(0);

        case WM_PAINT:

            hdc=BeginPaint(hwnd,&ps);

            nPaintBeg=max(0,nVscrollPos+
                    ps.rcPaint.top/cyChar-1);
            nPaintEnd=min(lLastRec,nVscrollPos+
                    ps.rcPaint.bottom/cyChar);

            hFont=GetStockObject(SYSTEM_FIXED_FONT);
            SelectObject(hdc,hFont);

            ForDBGoto(nPaintBeg+1);

            x=cxChar*(1-nHscrollPos);
            for(j=0;j<wFCount;j++)
            {
                ForDBField(&fi,j+1);
                TextOut(hdc,x,0,fi.achName,
                    strlen(fi.achName));

                if(fi.chType=='L')
                {
                    x+=4*cxChar;
                }
                else
                {
                    x+=(fi.wLen+1)*cxChar;
                }
            }

            for(i=nPaintBeg;i<nPaintEnd;i++,ForDBSkip(1))
            {
                x=cxChar*(1-nHscrollPos);
                y=cyChar*(1-nVscrollPos+i);

                if(y<cyChar)
                {
                    continue;
                }

                for(j=0;j<wFCount;j++)
                {
                    ForDBField(&fi,j+1);

                    if(fi.chType=='N')
                    {
                        x+=fi.wLen*cxChar;
                        SetTextAlign(hdc,TA_TOP|TA_RIGHT);
                    }

                    ForDBFieldGetVal(j+1,achBuff,sizeof(achBuff));
                    TextOut(hdc,x,y,achBuff,strlen(achBuff));

                    if(fi.chType=='N')
                    {
                        x+=cxChar;
                        SetTextAlign(hdc,TA_TOP|TA_LEFT);
                    }
                    else
                    {
                        if(fi.chType=='L')
                        {
                            x+=4*cxChar;
                        }
                        else
                        {
                            x+=(fi.wLen+1)*cxChar;
                        }
                    }
                }
            }

            EndPaint(hwnd,&ps);
            return(0);

        case WM_DESTROY:

            PostQuitMessage(0);
            return(0);


    }

    return(DefWindowProc(hwnd,message,wParam,lParam));

}
